package graph;

import java.util.TreeSet;
import java.util.Vector;

public class Graph {

	private Vector<Vector<Aresta> > adj;
	private Vector<Integer> parnt;

	public Graph(int n) {
		
		adj = new Vector<Vector<Aresta> >();
		for(int i = 0;i < n;i++)adj.add(new Vector<Aresta>());
		parnt = new Vector<Integer>();
		for(int i = 0;i < n;i++)parnt.add(-1);
	}

	public int size(){
		return adj.size();
	}
	
	public Vector<Aresta> getNeigh(int vertex){
		return adj.get(vertex);
	}
	
	public int getVertex(int vertexI,int edgeN){
		return adj.get(vertexI).get(edgeN).getVertice();
	}

	public void insert(int v,int w,double cst){
		if(adj.get(v) == null)
			adj.set(v, new Vector<Aresta>());

		adj.get(v).add(new Aresta(w,cst));
	}

	public void dfs(int v,int w){
		if(v == w)return;
		for(int i = 0;i < adj.get(v).size();i++){
			if(parnt.get(adj.get(v).get(i).getVertice()) == -1){
				parnt.set(adj.get(v).get(i).getVertice(), v);
				dfs(adj.get(v).get(i).getVertice(),w);
			}
		}
	}

	public Vector<Integer> dijkstra(int inicio,int fim){
		
		TreeSet<Aresta> pq = new TreeSet<Aresta>(); 
		Vector<Double> dist = new Vector<Double>();

		for(int i = 0;i < parnt.size();i++){
			parnt.set(i, -1);
			dist.add(Double.POSITIVE_INFINITY);
		}
		dist.set(inicio,0.0);
		pq.add(new Aresta(inicio,0));


		while(!pq.isEmpty()){
			Aresta v = pq.first();
			pq.remove(v);
			
			for(int i = 0;i < adj.get(v.getVertice()).size();i++){
				Aresta w = adj.get(v.getVertice()).get(i);
				if(v.getCusto() + w.getCusto() < dist.get(w.getVertice())){
					Aresta temp = new Aresta(w.getVertice(), v.getCusto() + w.getCusto());

					dist.set(temp.getVertice(), temp.getCusto());
					parnt.set(temp.getVertice(), v.getVertice());
					pq.add(temp);
				}
			}
		}
		return parnt;
	}
}
