package io;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Collections;
import java.util.Scanner;
import java.util.Vector;


import utils.Point;
import utils.Polygon;

public class IO {
    static Vector<Polygon> mapa = null;
    static Point ini = null;
    static Point fim = null;

    public static Point getInitialPoint(){
        return ini;
    }
    public static Point getFinalPoint(){
        return fim;
    }
    public static Vector<Polygon> getMap(){
        return mapa;
    }

    static Polygon read_polygon(Scanner s) {

        Polygon p = new Polygon();
        int n = s.hasNextInt() ? s.nextInt() : 0;
        for (int i = 0; i < n; i++) {
            double x = s.nextInt();
            double y = s.nextInt();

            p.add(new Point(x, y));
        }
        return p;
    }

    public static void save(Vector<Polygon> mapa, Point initialPoint, Point finalPoint, File out) throws IOException {
        FileWriter fw;
        fw = new FileWriter(out);
        fw.write(mapa.size() + "\n");
        for (int i = 0; i < mapa.size(); i++) {
            fw.write(mapa.get(i).size() + "\n");
            for (int j = 0; j < mapa.get(i).size(); j++) {
                fw.write((int) mapa.get(i).get(j).getX() + "\n" + (int) mapa.get(i).get(j).getY() + "\n");
            }
        }
        if(initialPoint != null){
            fw.write((int)initialPoint.getX() + "\n" + (int) initialPoint.getY() + "\n");
            if(finalPoint != null)
                fw.write((int) finalPoint.getX() + "\n" + (int) finalPoint.getY() + "\n");
        }
        fw.close();
    }

    public static void le(File in) throws FileNotFoundException {

        Scanner s = new Scanner(in);
        int n = s.hasNextInt() ? s.nextInt() : 0;
        if(n > 0)mapa = new Vector<Polygon>();
        for (int i = 0; i < n; i++) {
            mapa.add(read_polygon(s));
        }
        if(s.hasNextInt()){
            ini = new Point(s.nextInt(), s.nextInt());
        }else ini = null;

        if(s.hasNextInt()){
            fim = new Point(s.nextInt(), s.nextInt());
        }
        else fim = null;

        s.close();
    }

    public static void saveLejosProgram(Vector<Point> path, File out) throws IOException {
        FileWriter fw;
        fw = new FileWriter(out);
        
        Collections.reverse(path);

        fw.write("import lejos.nxt.*;\n");
        fw.write("import lejos.robotics.navigation.*;\n");


        fw.write("public class " + out.getName().substring(0, out.getName().length()-5) + "\n");
        fw.write("{\n");
        fw.write("   static SimpleNavigator simpleNav;\n");
        fw.write("   public static void main( String[] args)\n");
        fw.write("   {\n");
        fw.write("      simpleNav = new SimpleNavigator(new TachoPilot(5.6f,12.1f,Motor.A,Motor.B,true));\n");
        fw.write("      System.out.println(\"Walking!\");\n");
        fw.write("      simpleNav.setPosition(" + (int) path.get(0).getX() + "," + (int) path.get(0).getY() + ",90);\n");
        for (int i = 1; i < path.size(); i++) {
            fw.write("      simpleNav.goTo(" + (int) path.get(i).getX() + "," + (int) path.get(i).getY() + ");\n");
        }
        fw.write("      System.out.println(\"Done!\");\n");
        fw.write("      Button.waitForPress();\n");
        fw.write("   }\n");
        fw.write("}\n\n");

        fw.close();
    }
}
