/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * JInterfacePrincipal.java
 *
 * Created on 07/11/2009, 14:25:14
 */
package main;

import graph.Graph;
import graph.VisibilityGraphCalculator;
import io.IO;
import java.awt.Graphics;
import java.awt.Image;
import java.io.File;
import java.io.IOException;
import java.util.Scanner;
import java.util.Vector;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JFileChooser;
import utils.Point;
import utils.Polygon;
import utils.RandomGenerator;
import utils.Segment;

/**
 *
 * @author natan
 */
public class JInterfacePrincipal extends javax.swing.JFrame implements Interface, Runnable {

    private Image buffer;
    protected static final long REFRESH_RATE = 20;
    private Vector<Polygon> mapa;
    private Graph graph;
    private Point pivo;
    private Point otherPoint;
    private Vector<Segment> sweep;
    private Vector<Point> minimumPath;
    private Segment sweepLineFirst;
    private VisibilityGraphCalculator calculator;
    private boolean calculating = false;
    private Thread tr;
    private boolean closed = false;
    private Segment dir;
    private long algorithmDelay = 300;
    private Config config;
    private Point initialPoint;
    private Point finalPoint;
    private boolean polygonIsOpen = false;
    private Polygon incompletePolygon;
    private boolean catchInitialPoint;
    private boolean catchFinalPoint;

    /** Creates new form JInterfacePrincipal */
    public JInterfacePrincipal() {
        initComponents();
        config = new Config(null, true);
    }

    private void drawPolygon(Polygon pol, Graphics gImage) {
        int[] polx = new int[pol.size()];
        int[] poly = new int[pol.size()];
        int polIndex = 0;
        for (int j = 0; j < pol.size(); j++) {
            polx[polIndex] = (int) pol.get(j).getX();
            poly[polIndex++] = (int) pol.get(j).getY();
        }
        gImage.drawPolygon(polx, poly, pol.size());
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLayeredPane1 = new javax.swing.JLayeredPane();
        canvas = new java.awt.Canvas(){
            @Override
            public void paint(Graphics g) {
                buffer = createImage(canvas.getWidth(), canvas.getHeight());
                desenhaTela(buffer.getGraphics());
                g.drawImage(buffer, 0, 0, this);
            }

            @Override
            public void update(Graphics g) {
                paint(g);
            }
        }
        ;
        menu = new javax.swing.JMenuBar();
        jMenu1 = new javax.swing.JMenu();
        jMenuItemSave = new javax.swing.JMenuItem();
        jMenuItemLoad = new javax.swing.JMenuItem();
        jMenuItem3 = new javax.swing.JMenuItem();
        jMenuItemExit = new javax.swing.JMenuItem();
        jMenu2 = new javax.swing.JMenu();
        jMenuItemGeneratePolygons = new javax.swing.JMenuItem();
        jMenuItemGeneratePoint = new javax.swing.JMenuItem();
        jMenuItemClosePolygon = new javax.swing.JMenuItem();
        jMenuItem1 = new javax.swing.JMenuItem();
        jMenuItem2 = new javax.swing.JMenuItem();
        jMenuItemClear = new javax.swing.JMenuItem();
        jMenuItemProperties = new javax.swing.JMenuItem();
        jMenu3 = new javax.swing.JMenu();
        jMenuItemCalculate = new javax.swing.JMenuItem();
        jMenuItemDelayPlus = new javax.swing.JMenuItem();
        jMenuItemDelayMinus = new javax.swing.JMenuItem();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Visibility Graphs");

        canvas.setBackground(new java.awt.Color(255, 255, 255));
        canvas.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                canvasMouseClicked(evt);
            }
        });
        getContentPane().add(canvas, java.awt.BorderLayout.CENTER);

        jMenu1.setText("File");

        jMenuItemSave.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_S, java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemSave.setText("Save");
        jMenuItemSave.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemSaveActionPerformed(evt);
            }
        });
        jMenu1.add(jMenuItemSave);

        jMenuItemLoad.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_O, java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemLoad.setText("Load");
        jMenuItemLoad.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemLoadActionPerformed(evt);
            }
        });
        jMenu1.add(jMenuItemLoad);

        jMenuItem3.setText("Save Lejos Program");
        jMenuItem3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem3ActionPerformed(evt);
            }
        });
        jMenu1.add(jMenuItem3);

        jMenuItemExit.setText("Exit");
        jMenuItemExit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemExitActionPerformed(evt);
            }
        });
        jMenu1.add(jMenuItemExit);

        jMenu1.getPopupMenu().setLightWeightPopupEnabled(false);

        menu.add(jMenu1);

        jMenu2.setText("Edit");

        jMenuItemGeneratePolygons.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_G, java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemGeneratePolygons.setText("Generate Polygons");
        jMenuItemGeneratePolygons.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemGeneratePolygonsActionPerformed(evt);
            }
        });
        jMenu2.add(jMenuItemGeneratePolygons);

        jMenuItemGeneratePoint.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_H, java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemGeneratePoint.setText("Generate Points");
        jMenuItemGeneratePoint.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemGeneratePointActionPerformed(evt);
            }
        });
        jMenu2.add(jMenuItemGeneratePoint);

        jMenuItemClosePolygon.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_ENTER, java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemClosePolygon.setText("Close Polygon");
        jMenuItemClosePolygon.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemClosePolygonActionPerformed(evt);
            }
        });
        jMenu2.add(jMenuItemClosePolygon);

        jMenuItem1.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_I, java.awt.event.InputEvent.CTRL_MASK));
        jMenuItem1.setText("Generate Initial Point");
        jMenuItem1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem1ActionPerformed(evt);
            }
        });
        jMenu2.add(jMenuItem1);

        jMenuItem2.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_F, java.awt.event.InputEvent.CTRL_MASK));
        jMenuItem2.setText("Generate Final Point");
        jMenuItem2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem2ActionPerformed(evt);
            }
        });
        jMenu2.add(jMenuItem2);

        jMenuItemClear.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_D, java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemClear.setText("Clear");
        jMenuItemClear.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemClearActionPerformed(evt);
            }
        });
        jMenu2.add(jMenuItemClear);

        jMenuItemProperties.setText("Properties");
        jMenuItemProperties.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemPropertiesActionPerformed(evt);
            }
        });
        jMenu2.add(jMenuItemProperties);

        menu.add(jMenu2);
        jMenu2.getPopupMenu().setLightWeightPopupEnabled(false);

        jMenu3.setText("Graph");

        jMenuItemCalculate.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_J, java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemCalculate.setText("Calculate");
        jMenuItemCalculate.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemCalculateActionPerformed(evt);
            }
        });
        jMenu3.add(jMenuItemCalculate);

        jMenuItemDelayPlus.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_P, java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemDelayPlus.setText("delay ++");
        jMenuItemDelayPlus.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemDelayPlusActionPerformed(evt);
            }
        });
        jMenu3.add(jMenuItemDelayPlus);

        jMenuItemDelayMinus.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_M, java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemDelayMinus.setText("delay --");
        jMenuItemDelayMinus.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemDelayMinusActionPerformed(evt);
            }
        });
        jMenu3.add(jMenuItemDelayMinus);

        menu.add(jMenu3);
        jMenu3.getPopupMenu().setLightWeightPopupEnabled(false);

        setJMenuBar(menu);

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-800)/2, (screenSize.height-625)/2, 800, 625);
    }// </editor-fold>//GEN-END:initComponents

    private void jMenuItemExitActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemExitActionPerformed
        System.exit(0);
    }//GEN-LAST:event_jMenuItemExitActionPerformed

    private void jMenuItemLoadActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemLoadActionPerformed
        if (!calculating) {
            jMenuItemClearActionPerformed(evt);
            JFileChooser filechooser = new JFileChooser();

            if (filechooser.showOpenDialog(null) == JFileChooser.APPROVE_OPTION) {
                File file = filechooser.getSelectedFile();
                try {
                    IO.le(file);
                    setMapa(IO.getMap());
                    setInitialPoint(IO.getInitialPoint());
                    setFinalPoint(IO.getFinalPoint());
                } catch (IOException e1) {
                    e1.printStackTrace();
                }
            }
        }
    }//GEN-LAST:event_jMenuItemLoadActionPerformed

    private void jMenuItemSaveActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemSaveActionPerformed
        if (!calculating) {
            JFileChooser filechooser = new JFileChooser();

            if (filechooser.showSaveDialog(null) == JFileChooser.APPROVE_OPTION) {
                File file = filechooser.getSelectedFile();
                try {
                    IO.save(getMapa(), getInitialPoint(), getFinalPoint(), file);
                } catch (IOException e1) {
                    e1.printStackTrace();
                }
            }
        }
    }//GEN-LAST:event_jMenuItemSaveActionPerformed

    private void jMenuItemGeneratePolygonsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemGeneratePolygonsActionPerformed
        if (!calculating) {
            apagatudo();
            setMapa(RandomGenerator.criaConjuntoDePoligonosAleatorios(0, 0, canvas.getWidth() - 10, canvas.getHeight() - 10));
            setInitialPoint(null);
            setFinalPoint(null);
        }
    }//GEN-LAST:event_jMenuItemGeneratePolygonsActionPerformed

    private void jMenuItemPropertiesActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemPropertiesActionPerformed
        config.setVisible(true);
    }//GEN-LAST:event_jMenuItemPropertiesActionPerformed

    private void jMenuItemCalculateActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemCalculateActionPerformed
        if (!calculating) {
            apagatudo();
            calculating = true;
            tr = new Thread(new Runnable() {

                @Override
                public void run() {
                    if (mapa != null && initialPoint != null && finalPoint != null) {
                        for (Polygon p : mapa) {
                            for (Point pp : p.vertex) {
                                pp.setX((int)pp.getX());
                                pp.setY((int)pp.getY());
                            }
                        }
                        for (Polygon p : mapa) {
                            for (Point pp : p.vertex) {
                                pp.setX(pp.getX() + Math.random()/10.0);
                                pp.setY(pp.getY() + Math.random()/10.0);
                            }
                        }

                        calculator.calculate(getMapa(), getInitialPoint(), getFinalPoint());
                    }

                    calculating = false;
                }
            });
            tr.start();
        }
    }//GEN-LAST:event_jMenuItemCalculateActionPerformed

    private void jMenuItemGeneratePointActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemGeneratePointActionPerformed
        if (!calculating) {
            apagatudo();
            setInitialPoint(RandomGenerator.criaPontoAleatorios(mapa, 0, 0, canvas.getWidth() - 10, canvas.getHeight() - 10));
            setFinalPoint(RandomGenerator.criaPontoAleatorios(mapa, 0, 0, canvas.getWidth() - 10, canvas.getHeight() - 10));
        }
    }//GEN-LAST:event_jMenuItemGeneratePointActionPerformed

    private void jMenuItemDelayPlusActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemDelayPlusActionPerformed
        algorithmDelay *= 2;
        algorithmDelay++;
        System.out.println(algorithmDelay);
    }//GEN-LAST:event_jMenuItemDelayPlusActionPerformed

    private void jMenuItemDelayMinusActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemDelayMinusActionPerformed
        algorithmDelay /= 2;
        System.out.println(algorithmDelay);
    }//GEN-LAST:event_jMenuItemDelayMinusActionPerformed

    private void jMenuItem3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem3ActionPerformed
        if (!calculating) {
            JFileChooser filechooser = new JFileChooser();

            if (filechooser.showSaveDialog(null) == JFileChooser.APPROVE_OPTION) {
                File file = filechooser.getSelectedFile();
                try {
                    IO.saveLejosProgram(minimumPath, file);

                    Runtime r = Runtime.getRuntime();

                    String nome = file.getName();
                    String nomeSemExt = nome.substring(0, nome.length() - 5);
                    File home = new File(config.getHomeDir());
                    Process p = r.exec(config.getHomeDir() + "/uploadLego.sh " + nomeSemExt, null, home);


                    Scanner sc = new Scanner(p.getInputStream());
                    while (sc.hasNext()) {
                        System.out.println(sc.nextLine());
                    }
                } catch (IOException e1) {
                    e1.printStackTrace();
                }
            }
        }
    }//GEN-LAST:event_jMenuItem3ActionPerformed

    private void canvasMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_canvasMouseClicked
        if (!calculating) {
            apagatudo();
            if (catchInitialPoint) {
                catchInitialPoint = false;
                setInitialPoint(new Point(evt.getX(), evt.getY()));
            } else if (catchFinalPoint) {
                catchFinalPoint = false;
                setFinalPoint(new Point(evt.getX(), evt.getY()));
            } else if (polygonIsOpen) {
                incompletePolygon.add(new Point(evt.getX(), evt.getY()));
            } else {
                polygonIsOpen = true;
                incompletePolygon = new Polygon();
                incompletePolygon.add(new Point(evt.getX(), evt.getY()));
            }
        }
    }//GEN-LAST:event_canvasMouseClicked

    private void jMenuItemClosePolygonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemClosePolygonActionPerformed
        if (!calculating) {
            if (incompletePolygon == null) {
                return;
            }
            if (mapa == null) {
                mapa = new Vector<Polygon>();
            }
            mapa.add(incompletePolygon);
            incompletePolygon = null;
            polygonIsOpen = false;
        }
    }//GEN-LAST:event_jMenuItemClosePolygonActionPerformed

    private void jMenuItemClearActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemClearActionPerformed
        if (!calculating) {
            polygonIsOpen = false;
            incompletePolygon = null;
            setMapa(null);
            setInitialPoint(null);
            setFinalPoint(null);
            apagatudo();
        }
    }//GEN-LAST:event_jMenuItemClearActionPerformed

    private void jMenuItem1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem1ActionPerformed
        catchInitialPoint = true;
    }//GEN-LAST:event_jMenuItem1ActionPerformed

    private void jMenuItem2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem2ActionPerformed
        catchFinalPoint = true;
    }//GEN-LAST:event_jMenuItem2ActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                JInterfacePrincipal jinterface = new JInterfacePrincipal();
                jinterface.setCalculator(new VisibilityGraphCalculator(jinterface));

                Thread tr = new Thread(jinterface);


                jinterface.setVisible(true);
                tr.start();
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private java.awt.Canvas canvas;
    private javax.swing.JLayeredPane jLayeredPane1;
    private javax.swing.JMenu jMenu1;
    private javax.swing.JMenu jMenu2;
    private javax.swing.JMenu jMenu3;
    private javax.swing.JMenuItem jMenuItem1;
    private javax.swing.JMenuItem jMenuItem2;
    private javax.swing.JMenuItem jMenuItem3;
    private javax.swing.JMenuItem jMenuItemCalculate;
    private javax.swing.JMenuItem jMenuItemClear;
    private javax.swing.JMenuItem jMenuItemClosePolygon;
    private javax.swing.JMenuItem jMenuItemDelayMinus;
    private javax.swing.JMenuItem jMenuItemDelayPlus;
    private javax.swing.JMenuItem jMenuItemExit;
    private javax.swing.JMenuItem jMenuItemGeneratePoint;
    private javax.swing.JMenuItem jMenuItemGeneratePolygons;
    private javax.swing.JMenuItem jMenuItemLoad;
    private javax.swing.JMenuItem jMenuItemProperties;
    private javax.swing.JMenuItem jMenuItemSave;
    private javax.swing.JMenuBar menu;
    // End of variables declaration//GEN-END:variables

    public void setInitialPoint(Point initialPoint) {
        this.initialPoint = initialPoint;
    }

    public Point getInitialPoint() {
        return initialPoint;
    }

    public void setFinalPoint(Point finalPoint) {
        this.finalPoint = finalPoint;
    }

    public Point getFinalPoint() {
        return finalPoint;
    }

    @Override
    public void setPivo(Point pivo) {
        this.pivo = pivo;

    }

    @Override
    public void setOtherPoint(Point otherPoint) {
        this.otherPoint = otherPoint;
    }

    @Override
    public void setSweepLineFirst(Segment sweepLineFirst) {
        this.sweepLineFirst = sweepLineFirst;
    }

    @Override
    public void setGraph(Graph graph) {
        this.graph = graph;
    }

    @Override
    public void setDirection(Segment dir) {
        this.dir = dir;
    }

    @Override
    public void setMinimumPath(Vector<Point> path) {
        this.minimumPath = path;
    }

    @Override
    public void setSweep(Vector<Segment> sweep) {
        this.sweep = sweep;
    }

    @Override
    public void setCalculating(boolean calculating) {
        this.calculating = calculating;
    }

    public void setAlgorithmDelay(long algorithmDelay) {
        this.algorithmDelay = algorithmDelay;
    }

    public long getAlgorithmDelay() {
        return algorithmDelay;
    }

    @Override
    public int passo() {
        if (closed) {
            System.out.println("fechei");
            return -1;
        }

        try {
            Thread.sleep(getAlgorithmDelay());
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        return 1;
    }

    private void setMapa(Vector<Polygon> mapa) {
        this.mapa = mapa;

    }

    private Vector<Polygon> getMapa() {
        return mapa;
    }

    private synchronized void desenhaTela(Graphics gImage) {

//        speedView.setText("Velocidade de delay:" + getAlgorithmDelay() + "ms");
//        System.out.println("Velocidade de delay:" + getAlgorithmDelay() + "ms");

if (getMapa() != null) {
            gImage.setColor(config.getPoligonosColor());
            drawPolygons(gImage, getMapa());
            //          mapSizeView.setText(getMapa().size() + " polígonos");
        }

        if (graph != null) {
            gImage.setColor(config.getGrafoColor());
            drawGraph(gImage, graph, calculator.getVertexPointRelation());
        }
        
        

        if (sweep != null) {
            int t = 0;
            for (Segment segment : sweep) {
                gImage.setColor(config.getSweepColor());
                gImage.drawLine((int) segment.getA().getX(), (int) segment.getA().getY(), (int) segment.getB().getX(), (int) segment.getB().getY());
//				gcImage.setForeground(shell.getDisplay().getSystemColor(SWT.COLOR_BLACK));
//				gcImage.setBackground(shell.getDisplay().getSystemColor(SWT.COLOR_WHITE));
                gImage.drawString("" + t++, (int) ((segment.getA().getX() + segment.getB().getX()) / 2.0), (int) ((segment.getA().getY() + segment.getB().getY()) / 2.0));
            }
        }

        if (sweepLineFirst != null && sweepLineFirst.getA() != null && sweepLineFirst.getB() != null) {
            gImage.setColor(config.getSweepFirstColor());
//			gcImage.setForeground(shell.getDisplay().getSystemColor(SWT.COLOR_RED));
            gImage.drawLine((int) sweepLineFirst.getA().getX(), (int) sweepLineFirst.getA().getY(), (int) sweepLineFirst.getB().getX(), (int) sweepLineFirst.getB().getY());
        }

        if (minimumPath != null) {
            gImage.setColor(config.getMinimunPathColor());
//			gcImage.setForeground(shell.getDisplay().getSystemColor(SWT.COLOR_GREEN));
            drawPath(gImage, minimumPath);
        }
        if (dir != null) {
            gImage.setColor(config.getDirectionColor());
//			gcImage.setForeground(shell.getDisplay().getSystemColor(SWT.COLOR_DARK_GREEN));
            gImage.drawLine((int) dir.getA().getX(), (int) dir.getA().getY(), (int) dir.getB().getX(), (int) dir.getB().getY());
        }
        if (pivo != null) {
            gImage.setColor(config.getPivotColor());
            gImage.drawRect((int) pivo.getX() - 3, (int) pivo.getY() - 3, 6, 6);
        }

        if (otherPoint != null) {
            gImage.setColor(config.getOtherPointColor());
//			gcImage.setBackground(shell.getDisplay().getSystemColor(SWT.COLOR_BLUE));
            gImage.drawRect((int) otherPoint.getX() - 3, (int) otherPoint.getY() - 3, 6, 6);
        }
        if (finalPoint != null) {
            gImage.setColor(config.getFinalPointColor());
            gImage.drawRect((int) finalPoint.getX() - 3, (int) finalPoint.getY() - 3, 6, 6);
        }
        if (initialPoint != null) {
            gImage.setColor(config.getInitialPointColor());
            gImage.drawRect((int) initialPoint.getX() - 3, (int) initialPoint.getY() - 3, 6, 6);
        }
        if (incompletePolygon != null) {
            drawPolygon(incompletePolygon, gImage);
        }

    }

    @Override
    public void run() {
        while (isDisplayable()) {
            if (canvas != null) {
                canvas.repaint();
            }
            try {
                Thread.sleep(JInterfacePrincipal.REFRESH_RATE);
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
        }
    }

    private void drawPath(Graphics gImage, Vector<Point> path) {
        for (int i = 0; i < path.size() - 1; i++) {
            Point p1 = path.get(i);
            Point p2 = path.get(i + 1);
            gImage.drawLine((int) p1.getX(), (int) p1.getY(), (int) p2.getX(), (int) p2.getY());
        }
    }

    private void drawPolygons(Graphics gImage, Vector<Polygon> map) {

        for (int i = 0; i < map.size(); i++) {
            drawPolygon(map.get(i), gImage);
        }
    }

    private void drawGraph(Graphics gImage, Graph graph, Vector<Point> vertexPointRelation) {
        for (int i = 0; i < graph.size(); i++) {
            for (int j = 0; j < graph.getNeigh(i).size(); j++) {
                Point orig = vertexPointRelation.get(i);
                Point dest = vertexPointRelation.get(graph.getNeigh(i).get(j).getVertice());
                gImage.drawLine((int) orig.getX(), (int) orig.getY(), (int) dest.getX(), (int) dest.getY());

            }
        }
    }

    private void setCalculator(VisibilityGraphCalculator visibilityGraphCalculator) {
        calculator = visibilityGraphCalculator;
    }

    private void apagatudo() {
        setMinimumPath(null);
        setSweep(null);
        setDirection(null);
        setGraph(null);
        setSweepLineFirst(null);
    }

    @Override
    public int getWidth() {
        return canvas.getWidth();
    }

    @Override
    public int getHeight() {
        return canvas.getHeight();
    }
}
