package utils;

import graph.VisibilityGraphCalculator;
import java.util.Collections;
import java.util.Comparator;
import java.util.Vector;

public class Polygon {
	public Vector<Point> vertex;
        public final double EPSILON = 1e-9;
	
	public Polygon() {
		vertex = new Vector<Point>();
	}

	public void add(Point a){
		vertex.add(a);
	}

	public int size(){
		return vertex.size();
	}

	public boolean in(Point a){
		int Rcross = 0;
		int Lcross = 0;
		Vector<Point> V = new Vector<Point>();
		for(int i = 0;i < size();i++){
			Point novo = new Point(vertex.get(i).getX() - a.getX(),vertex.get(i).getY() - a.getY());
			V.add(novo);
		}
		for(int i = 0;i < size();i++){
			if(Math.abs(V.get(i).getX()) <= EPSILON && Math.abs(V.get(i).getY()) <= EPSILON)return false;
			int i1 = (i + size() - 1) % size();

			boolean Rstrad = (V.get(i).getY() > 0) != (V.get(i1).getY() > 0);
			boolean Lstrad = (V.get(i).getY() < 0) != (V.get(i1).getY() < 0);

			if(Rstrad || Lstrad){
				double x = (V.get(i).getX() * V.get(i1).getY() - V.get(i1).getX() * V.get(i).getY())
				/ (V.get(i1).getY() - V.get(i).getY());
				if(Rstrad && x > 0)Rcross++;
				if(Lstrad && x < 0)Lcross++;
			}
		}
		if((Rcross%2) != (Lcross%2))return false;
		if((Rcross%2) == 1)return true;
		return false;
	}
	
	public static Polygon cria_polygono_aleatorio(int x,int y,int width,int height,int n){
            Polygon novo = new Polygon();
            Vector<Point> vet = new Vector<Point>();
            Point pivo = null;
            

            for(int i = 0;i < n-1;i++){
                vet.add(new Point(RandomGenerator.generate(x, x+width), RandomGenerator.generate(y, y+height)));
                if(pivo == null || vet.get(i).getY() > pivo.getY())pivo = vet.get(i);
            }

            VisibilityGraphCalculator.setPivot(pivo);
            Collections.sort(vet);
            

            for(Point p : vet){
                novo.add(p);
            }
            
            return novo;
	}

	public Point get(int index) {
		if(index < vertex.size())return vertex.get(index);
		return null;
	}


}
