package utils;

import java.util.Vector;

public class RandomGenerator {

    private static final int TOLERANCIA_TAMANHO = 50;//no minimo cada lado dos poligonos tem 50 pixels
    private static final double PROB_TER_POLIGONO = 0.5;//prob no caso base de ter um poligono
    private static final int TAMANHO_ESPERADO = 100;
    private static Vector<Polygon> res;

    public static double generate(int low, int high) {
        double k;
        double d;
        d = Math.random();
        k = d * (high - low + 1);
        return low + k;
    }

    public static Vector<Polygon> criaConjuntoDePoligonosAleatorios(int xini, int yini, int xfim, int yfim) {
        res = new Vector<Polygon>();
        RandomGenerator rg = new RandomGenerator();
        rg.criaConjuntoDePoligonosAleatoriosREC(xini, yini, xfim, yfim);
        return res;
    }

    public static Point criaPontoAleatorios(Vector<Polygon> mapa, int xini, int yini, int xfim, int yfim) {
        if (mapa == null) {
            return null;
        }
        Point p = new Point();
        do {
            p.setX(generate(xini, xfim));
            p.setY(generate(yini, yfim));
        } while (dentroDePoligono(p,mapa));
        return p;
    }

    private static boolean dentroDePoligono(Point p,Vector<Polygon> mapa) {
        for(Polygon pol : mapa){
            if(pol.in(p))return true;
        }
        return false;
    }

    private void criaConjuntoDePoligonosAleatoriosREC(int xini, int yini, int xfim, int yfim) {
        if (xfim - xini <= TOLERANCIA_TAMANHO || yfim - yini <= TOLERANCIA_TAMANHO) {
            return;
        }
        if (xfim - xini <= TAMANHO_ESPERADO || yfim - yini <= TAMANHO_ESPERADO) {
            if (Math.random() <= PROB_TER_POLIGONO) {
                res.add(Polygon.cria_polygono_aleatorio(xini, yini, xfim - xini, yfim - yini, (int)RandomGenerator.generate(4, 8)));
            }
        } else {
            double xdiv = RandomGenerator.generate(xini, xfim);
            double ydiv = RandomGenerator.generate(yini, yfim);
            criaConjuntoDePoligonosAleatoriosREC((int)xini+1, (int)yini+1, (int)xdiv - 2, (int)ydiv - 2);
            criaConjuntoDePoligonosAleatoriosREC((int)xini+2, (int)ydiv+2, (int)xdiv - 2, yfim);
            criaConjuntoDePoligonosAleatoriosREC((int)xdiv+3, (int)yini+3, xfim, (int)ydiv - 2);
            criaConjuntoDePoligonosAleatoriosREC((int)xdiv+4, (int)ydiv+4, xfim, yfim);
        }
    }
}
